var shiori_array = null;

function shiori_normalizeURL(url) {
	return url.replace(/#.*$/g, "").replace(/ /g, "%20");
}

function shiori_remove() {
	var url = shiori_normalizeURL(gBrowser.currentURI.spec);
	for(var i = shiori_array.length-2; i>=0; i-=2){
		if(shiori_array[i] == url){
			shiori_array.splice(i, 2);
		}
	}
	shiori_setPref(shiori_array);
	shiori_makeMenu();
}

function shiori_removeAll() {
	shiori_array = new Array();
	shiori_setPref(shiori_array);
	shiori_makeMenu();
}

function shiori_memorize() {
	var url = shiori_normalizeURL(gBrowser.currentURI.spec);
	shiori_remove();
	shiori_array.push(url);
	shiori_array.push(gBrowser.contentWindow.scrollY);
	shiori_setPref(shiori_array);
	shiori_makeMenu();
}

function shiori_load() {
	var url = shiori_normalizeURL(gBrowser.currentURI.spec);
	for(var i=0; i<shiori_array.length; i+=2){
		if(shiori_array[i] == url){
			gBrowser.contentWindow.scrollTo(0, shiori_array[i+1]);
			break;
		}
	}
}

function shiori_makeMenu() {
 	var mem = document.getElementById("shioriMemorizeMenu");
 	var sep1 = document.getElementById("shioriMenuSeparator1");
 	var sep2 = document.getElementById("shioriMenuSeparator2");
 	var rmv = document.getElementById("shioriRemoveMenu");
 	var rmva = document.getElementById("shioriRemoveAllMenu");
 	var res = document.getElementById("shioriRestoreMenu");

 	var parent = document.getElementById("ShioriMenuPopup");
 	for(var i=parent.childNodes.length-1; i>=0; i--){
		var node = parent.childNodes.item(i);
		if(node != mem && node != sep1 && node != sep2 &&
			node != rmv && node != rmva && node != res){
			parent.removeChild(node);
		}
	}

	for(var i=0; i<shiori_array.length; i+=2){
		var url = shiori_array[i];
		var idx = (i/2) + 1;
		var node = document.importNode(document.getElementById("shioriRestoreMenu"), false);
		node.id = "shioriRestoreMenu" + idx;
		parent.insertBefore(node, sep2);
		node.label = url;
		node.hidden = false;
		node.setAttribute("accesskey", idx);
		node.setAttribute("oncommand",
			'gBrowser.selectedTab = gBrowser.addTab(this.label, null);');
	}
}

function shiori_getPrefBranch(){
	if(!shiori_pref_branch_cache){
		shiori_pref_branch_cache = Components.classes["@mozilla.org/preferences-service;1"]
			.getService(Components.interfaces.nsIPrefBranch);
	}
	return shiori_pref_branch_cache;
}
var shiori_pref_branch_cache = null;

function shiori_setPref(array){
	var str = "";
	if(array.length > 0){ str = array.join(" "); }
	shiori_getPrefBranch().setCharPref("extensions.asukaze.shiori.data", str);
}

function shiori_getPref(){
	try{
		var branch = shiori_getPrefBranch();
		var str = branch.getCharPref("extensions.asukaze.shiori.data");
		if(str == null || str == ""){
			return new Array();
		}
		return str.split(" ");
	}catch(e){
		try{
			var str = branch.getCharPref("skz.shiori.data");
			if(str == null || str == ""){
				return new Array();
			}else{
				branch.setCharPref("extensions.asukaze.shiori.data", str);
				branch.deleteBranch("skz.shiori.data");
				return str.split(" ");
			}
		}catch(e){
			return new Array();
		}
	}
}

function shiori_init() {
	if(shiori_array == null){
		shiori_array = shiori_getPref();
		shiori_makeMenu();
	}
	gBrowser.addEventListener('load', shiori_load, true);
}
